﻿using System.Collections.Generic;
using System.Linq;
using AutoFixture;

namespace StreamEntityFrameworkOverWebApiCore31ViaBusinessService.Data
{
    public static class Seeder
    {
        public static void Seed(this SalesContext salesContext)
        {
            if (!salesContext.Products.Any())
            {
                Fixture fixture = new Fixture();
                fixture.Customize<Product>(product => product.Without(p => p.ProductId));
                //--- The next two lines add 10,000 rows to you database, this can take long time.
                List<Product> products = fixture.CreateMany<Product>(10000).ToList();
                salesContext.AddRange(products);
                salesContext.SaveChanges();
            }
        }
    }
}
